#!/usr/bin/python

####### USER SETTINGS ######
serialPort = "COM7"
slaveAddresses = [1,2,3]
interval = 10
debug = False
#################################################################

import timestamp
import pzem

ts = timestamp.interval(interval)
device = {}
data = {}

for i in slaveAddresses:
    try:
        device[i] = pzem.pzem(serialPort, i)
        if debug:
            device[i].debug = True
    except Exception as e:
        print("Device:" + str(i) + ", Setup Error:" + str(e))
    
try:
    while True:
        if ts.ready():
            for i in device:
                data[i] = False
                try:
                    data[i] = device[i].getData()
                except IOError as e:
                    print("Device:" + str(device[i].address) + ", IOError:" + str(e))
                except ValueError as e:
                    print("Device:" + str(device[i].address) + ", ValueError:" + str(e))
                except TypeError as e:
                    print("Device:" + str(device[i].address) + ", TypeError:" + str(e))
                except Exception as e:
                    print("Device:" + str(device[i].address) + ", Error:" + str(e))
                else:
                    if debug:
                        print("Succesfully read device:" + str(device[i].address) + ", Data:" + str(data[i]))

                if data[i]:
                    print(' '.join(str(v) for v in [ts.previous,device[i].address]+data[i]))
                else:
                    if debug:
                        print("No data found for device:" + str(device[i].address))

except KeyboardInterrupt:
    print("Exiting...")                         # Gracefully exit on "CTRL-C"
except Exception as e:
    print(e)


# TBD set alarm - write_register(1, newPower, 0, 6)
# TBD change address - write_register(2, newAddress, 0, 6)
# TBD reset energy - _performCommand(66,'')




# if __name__ == "__main__":
#     main()